<?php


/**
 * Essentially, this is a PURL record wrapper with some extra data.
 * (brynbellomy)
 */

class site {
  var $sid; // Unique site id
  var $purl_prefix;
  var $title;
  var $name;
  var $front_page;
  var $menu_primary_links;
  var $menu_secondary_links;
  var $tid;

  function __construct($title = '', $purl_prefix = '', $name = '', $front_page = '', $mpl = '', $msl = '', $sid = NULL, $tid = NULL) {
    $this->title = $title;
    $this->purl_prefix = $purl_prefix;
    $this->name = $name;
    $this->front_page = $front_page;
    $this->menu_primary_links = $mpl;
    $this->menu_secondary_links = $msl;
    $this->sid = $sid;
    
    $this->tid = $tid;
  }
  
  function load($sid) {
    $site = _sites_get_site($sid);
    if ($site) {
      $this->__construct($site->title, $site->purl_prefix, $site->name, $site->front_page, $site->menu_primary_links, $site->menu_secondary_links, $site->sid, $site->tid);
      return TRUE;
    }
    return FALSE;
  }

  function save() {
    $success = NULL;
    if ($this->sid == NULL) {
      if (count(_sites_get_sites()) == 0) {
        $this->sid = 1;
      }
      else {
        $this->sid = max(array_keys(_sites_get_sites())) + 1;
      }
      $success = drupal_write_record('sites', $this);
    }
    else {
      $success = drupal_write_record('sites', $this, 'sid');
    }
    if (!$success) {
      drupal_set_message('Failed to write site to DB.', 'error');
      return FALSE;
    }
    
    if ($success) {
      $modifier = array(
        'provider' => 'sites',
        'id' => $this->sid,
        'value' => $this->purl_prefix,
      );
      $success = purl_save($modifier);

      if (!$success) {
        drupal_set_message('Failed to write purl record to DB.', 'error');
      }
    }
    
    return $success;
  }
}
